﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Dynamic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Telerik.WinControls.RadControlSpy;
using Telerik.WinControls.UI;
using Telerik.WinForms.Documents.FormatProviders.OpenXml.Docx;
using Telerik.WinForms.Documents.Model;
using Telerik.WinForms.Documents.RichTextBoxCommands;
using Telerik.WinForms.RichTextEditor;

namespace _931671_RichTextEditorMailMergeDynamic
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            this.SetUpMergedFields();
        }

        private void SetUpMergedFields()
        {
            RadRibbonBarGroup mailGroup = ((RibbonTab)richTextEditorRibbonBar1.CommandTabs[4]).Items[0] as RadRibbonBarGroup;
            RadDropDownButtonElement dropdown = (RadDropDownButtonElement)mailGroup.Items[1];
            dropdown.Visibility = Telerik.WinControls.ElementVisibility.Collapsed;

            RadDropDownButtonElement myBtn = new RadDropDownButtonElement();
            myBtn.Text = "Insert Merge \nField";
            myBtn.Image = dropdown.Image;

            myBtn.TextImageRelation = dropdown.TextImageRelation;
            myBtn.ImageAlignment = dropdown.ImageAlignment;
            myBtn.TextAlignment = dropdown.TextAlignment;
            mailGroup.Items.Add(myBtn);


            foreach (string fieldName in this.GetMailMergeSource()[0].GetColumnNames())
            {
                RadMenuItem fieldMenu = new RadMenuItem();
                fieldMenu.Text = fieldName;
                fieldMenu.Click += fieldMenu_Click;
                myBtn.Items.Add(fieldMenu);
            }
        }

        private void fieldMenu_Click(object sender, EventArgs e)
        {
            RadMenuItem item = sender as RadMenuItem;

            MergeField parameter = new MergeField();
            parameter.PropertyPath = item.Text;
            parameter.DisplayMode = this.richTextEditorRibbonBar1.AssociatedRichTextEditor.RichTextBoxElement.Document.FieldsDisplayMode;

            var tb = this.richTextEditorRibbonBar1.AssociatedRichTextEditor.RichTextBoxElement.ActiveDocumentEditor as RadRichTextBox;
            InsertFieldCommand command = new InsertFieldCommand(tb);
            command.Execute(parameter);
            this.richTextEditorRibbonBar1.AssociatedRichTextEditor.ElementTree.Control.Focus();
        }

        private List<MyDynamicObject> GetMailMergeSource()
        {
            List<MyDynamicObject> mailMergeSource = new List<MyDynamicObject>();

            MyDynamicObject myDynamicObject = new MyDynamicObject();
            myDynamicObject.Set("FirstName", "John");
            myDynamicObject.Set("LastName", "Smith");
            myDynamicObject.Set("ContactName", "jsmith");
            myDynamicObject.Set("DateOfBirth", new DateTime(1980, 3, 18));

            mailMergeSource.Add(myDynamicObject);

            myDynamicObject = new MyDynamicObject();
            myDynamicObject.Set("FirstName", "Robert");
            myDynamicObject.Set("LastName", "Brown");
            myDynamicObject.Set("ContactName", "rbrown");
            myDynamicObject.Set("DateOfBirth", new DateTime(1990, 9, 25));
            mailMergeSource.Add(myDynamicObject);
            return mailMergeSource;
        }
    }
}
